// $Id:$

var StringToKeyCodeMap = new Array();  
var KeyCodeToStringMap = new Array();
var NextPhrasesMap = new Array();
var PrevPhrasesMap = new Array();
var NextImagesMap  = new Array();
var PrevImagesMap  = new Array();

var DefaultNextPhrases = new Array("Next", "next", "Next >", "next >", ">", "MORE RESULTS");  
var DefaultPrevPhrases = new Array("Previous", "previous", "Prev", "prev", "< Previous", "< previous", 
				   "PREVIOUS RESULTS", "< Prev", "< prev", "<", "<< Prev");

var DefaultNextImages = new Array("http://g-images.amazon.com/images/G/01/search-browse/button-more-results.gif");
var DefaultPrevImages = new Array("http://g-images.amazon.com/images/G/01/search-browse/button-previous.gif");

var keyBindingsChanged;

// Strip leading and trailing whitespace from
// the passed in string and return it.
function trim(str)
{
   return str.replace(/^\s*|\s*$/g,"");
}

function SetUnicharPref(prefs, aPrefName, aPrefValue)
{
   if (prefs)
   {
     try {
       var str = Components.classes["@mozilla.org/supports-string;1"]
                           .createInstance(Components.interfaces.nsISupportsString);
       str.data = aPrefValue;
       prefs.setComplexValue(aPrefName, Components.interfaces.nsISupportsString, str);
     }
     catch(e) {}
   }
}

function GetUnicharPref(prefs, aPrefName)
{
  if (prefs)
  {
    try {
      return prefs.getComplexValue(aPrefName, Components.interfaces.nsISupportsString).data;
    }
    catch(e) {}
  }
  return "";
}

// Initialize the lookup table for key name to keycode
function nextplease_initializeStringToKeyCodeMap(map)
{
    map["Left Arrow"] = KeyEvent.DOM_VK_LEFT;
    map["Right Arrow"] = KeyEvent.DOM_VK_RIGHT;
    map["Up Arrow"] = KeyEvent.DOM_VK_UP;
    map["Down Arrow"] = KeyEvent.DOM_VK_DOWN;
    map["Page Up"] = KeyEvent.DOM_VK_PAGE_UP;
    map["Page Down"] = KeyEvent.DOM_VK_PAGE_DOWN;
    map["Home"] = KeyEvent.DOM_VK_HOME;
    map["End"] = KeyEvent.DOM_VK_END;
    map["F1"] = KeyEvent.DOM_VK_F1;
    map["F2"] = KeyEvent.DOM_VK_F2;
    map["F3"] = KeyEvent.DOM_VK_F3;
    map["F4"] = KeyEvent.DOM_VK_F4;
    map["F5"] = KeyEvent.DOM_VK_F5;
    map["F6"] = KeyEvent.DOM_VK_F6;
    map["F7"] = KeyEvent.DOM_VK_F7;
    map["F8"] = KeyEvent.DOM_VK_F8;
    map["F9"] = KeyEvent.DOM_VK_F9;
    map["F10"] = KeyEvent.DOM_VK_F10;
    map["F11"] = KeyEvent.DOM_VK_F11;
    map["F12"] = KeyEvent.DOM_VK_F12;
}

// Initialize the lookup table for keycode to keyname
function nextplease_initializeKeyCodeToStringMap(map)
{
    map[KeyEvent.DOM_VK_LEFT] = "Left Arrow";
    map[KeyEvent.DOM_VK_RIGHT] = "Right Arrow";
    map[KeyEvent.DOM_VK_UP] = "Up Arrow";
    map[KeyEvent.DOM_VK_DOWN] = "Down Arrow";
    map[KeyEvent.DOM_VK_PAGE_UP] = "Page Up";
    map[KeyEvent.DOM_VK_PAGE_DOWN] = "Page Down";
    map[KeyEvent.DOM_VK_HOME] = "Home";
    map[KeyEvent.DOM_VK_END] = "End";
    map[KeyEvent.DOM_VK_F1] = "F1";
    map[KeyEvent.DOM_VK_F2] = "F2";
    map[KeyEvent.DOM_VK_F3] = "F3";
    map[KeyEvent.DOM_VK_F4] = "F4";
    map[KeyEvent.DOM_VK_F5] = "F5";
    map[KeyEvent.DOM_VK_F6] = "F6";
    map[KeyEvent.DOM_VK_F7] = "F7";
    map[KeyEvent.DOM_VK_F8] = "F8";
    map[KeyEvent.DOM_VK_F9] = "F9";
    map[KeyEvent.DOM_VK_F10] = "F10";
    map[KeyEvent.DOM_VK_F11] = "F11";
    map[KeyEvent.DOM_VK_F12] = "F12";
}

// Read the phrases that specify a next link
// by reading the preferences or defaults,
// populate the listbox with the phrases,
// and put the phrases in a lookup table.
function nextplease_initializeNextPhrases()
{
    var nextpleasePrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");

    var nextfieldsListbox = document.getElementById('nextfields');
    if (nextpleasePrefs.prefHasUserValue('nextplease.nextphrase.expr0'))
	{
	    var tempprefname = 'nextplease.nextphrase.expr0';
	    var i=0;
	    while (nextpleasePrefs.prefHasUserValue(tempprefname))
		{
		    //var phrase = nextpleasePrefs.getCharPref(tempprefname);
		    var phrase = GetUnicharPref(nextpleasePrefs,tempprefname, Components.interfaces.nsISupportsString);
		    nextfieldsListbox.appendItem(phrase, phrase);

		    // Scroll to the newly added item to workaround 
		    // what I think is a Firefox bug. I was getting
		    // Javascript exceptions when trying to read the
		    // values at the bottom that are "hidden".
		    nextfieldsListbox.ensureIndexIsVisible(i);
		    NextPhrasesMap[phrase] = true;
		    i++;
		    tempprefname = 'nextplease.nextphrase.expr'+i;
		}
	}
    else
	{
	    for (var i=0; i<DefaultNextPhrases.length; i++)
		{
		    var phrase = DefaultNextPhrases[i];
		    nextfieldsListbox.appendItem(phrase, phrase);
		    // Scroll to item to workaround Firefox bug.
		    nextfieldsListbox.ensureIndexIsVisible(i);
		    NextPhrasesMap[DefaultNextPhrases[i]] = true;
		}
	}
    nextfieldsListbox.ensureIndexIsVisible(0);
}

// Read the phrases that specify a previous link
// by reading the preferences or defaults,
// populate the listbox with the phrases,
// and put the phrases in a lookup table.
function nextplease_initializePrevPhrases()
{
    var nextpleasePrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");

    var prevfieldsListbox = document.getElementById('prevfields');

    if (nextpleasePrefs.prefHasUserValue('nextplease.prevphrase.expr0'))
	{
	    var tempprefname = 'nextplease.prevphrase.expr0';
	    var i=0;
	    while (nextpleasePrefs.prefHasUserValue(tempprefname))
		{
		    //   var phrase = nextpleasePrefs.getCharPref(tempprefname);
		    var phrase = GetUnicharPref(nextpleasePrefs,tempprefname, Components.interfaces.nsISupportsString);
		    prevfieldsListbox.appendItem(phrase, phrase);
		    // Scroll to item to workaround Firefox bug.
		    prevfieldsListbox.ensureIndexIsVisible(i);
		    PrevPhrasesMap[phrase] = true;
		    i++;
		    tempprefname = 'nextplease.prevphrase.expr'+i;
		}
	}
    else
	{
	    for (var i=0; i<DefaultPrevPhrases.length; i++)
		{
		    var phrase = DefaultPrevPhrases[i];
		    prevfieldsListbox.appendItem(phrase, phrase);
		    // Scroll to item to workaround Firefox bug.
		    prevfieldsListbox.ensureIndexIsVisible(i);
		    PrevPhrasesMap[DefaultPrevPhrases[i]] = true;
		}
	}
    prevfieldsListbox.ensureIndexIsVisible(0);
}

// Read the phrases that specify a next image link
// by reading the preferences or defaults,
// populate the listbox with the phrases,
// and put the phrases in a lookup table.
function nextplease_initializeNextImages()
{
    var nextpleasePrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");

    var nextfieldsListbox = document.getElementById('nextimagefields');
    if (nextpleasePrefs.prefHasUserValue('nextplease.nextimage.expr0'))
	{
	    var tempprefname = 'nextplease.nextimage.expr0';
	    var i=0;
	    while (nextpleasePrefs.prefHasUserValue(tempprefname))
		{
		    //var phrase = nextpleasePrefs.getCharPref(tempprefname);
		    var phrase = GetUnicharPref(nextpleasePrefs,tempprefname, Components.interfaces.nsISupportsString);
		    nextfieldsListbox.appendItem(phrase, phrase);
		    // Scroll to item to workaround Firefox bug.
		    nextfieldsListbox.ensureIndexIsVisible(i);
		    NextImagesMap[phrase] = true;
		    i++;
		    tempprefname = 'nextplease.nextimage.expr'+i;
		}
	}
    else
	{
	    for (var i=0; i<DefaultNextImages.length; i++)
		{
		    var phrase = DefaultNextImages[i];
		    nextfieldsListbox.appendItem(phrase, phrase);
		    // Scroll to item to workaround Firefox bug.
		    nextfieldsListbox.ensureIndexIsVisible(i);
		    NextImagesMap[DefaultNextImages[i]] = true;
		}
	}
    nextfieldsListbox.ensureIndexIsVisible(0);
}

// Read the phrases that specify a previous image link
// by reading the preferences or defaults,
// populate the listbox with the phrases,
// and put the phrases in a lookup table.
function nextplease_initializePrevImages()
{
    var nextpleasePrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");

    var prevfieldsListbox = document.getElementById('previmagefields');

    if (nextpleasePrefs.prefHasUserValue('nextplease.previmage.expr0'))
	{
	    var tempprefname = 'nextplease.previmage.expr0';
	    var i=0;
	    while (nextpleasePrefs.prefHasUserValue(tempprefname))
		{
		    //var phrase = nextpleasePrefs.getCharPref(tempprefname);
		    var phrase = GetUnicharPref(nextpleasePrefs,tempprefname, Components.interfaces.nsISupportsString);
		    prevfieldsListbox.appendItem(phrase, phrase);
		    // Scroll to item to workaround Firefox bug.
		    prevfieldsListbox.ensureIndexIsVisible(i);
		    PrevPhrasesMap[phrase] = true;
		    i++;
		    tempprefname = 'nextplease.previmage.expr'+i;
		}
	}
    else
	{
	    for (var i=0; i<DefaultPrevImages.length; i++)
		{
		    var phrase = DefaultPrevImages[i];
		    prevfieldsListbox.appendItem(phrase, phrase);
		    // Scroll to item to workaround Firefox bug.
		    prevfieldsListbox.ensureIndexIsVisible(i);
		    PrevPhrasesMap[DefaultPrevImages[i]] = true;
		}
	}
    prevfieldsListbox.ensureIndexIsVisible(0);
}

// Write out the preferences from the dialog.
function nextplease_saveOptions()
{
    var nextpleasePrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");

    nextpleasePrefs.setCharPref('nextplease.keymodifier', document.getElementById('nextpleaseModifier').value);

    var nextKeyString = trim(document.getElementById('nextkey').value);
    if (nextKeyString == '')
	nextpleasePrefs.setIntPref('nextplease.nextkey', StringToKeyCodeMap[document.getElementById('nextkeymenu').value]);
    else
	nextpleasePrefs.setIntPref('nextplease.nextkey', nextKeyString.toUpperCase().charCodeAt(0));

    var prevKeyString = trim(document.getElementById('prevkey').value);
    if (prevKeyString == '')
	nextpleasePrefs.setIntPref('nextplease.prevkey', StringToKeyCodeMap[document.getElementById('prevkeymenu').value]);
    else
	nextpleasePrefs.setIntPref('nextplease.prevkey', prevKeyString.toUpperCase().charCodeAt(0));
	
    // Save the next phrase listbox data
    var nextfieldsListbox = document.getElementById('nextfields');
    var numRows = nextfieldsListbox.getRowCount();
    nextpleasePrefs.deleteBranch('nextplease.nextphrase.');
    for (var i=0; i<numRows; i++)
	{
	    var tempprefname = 'nextplease.nextphrase.expr' + i;
	    // nextpleasePrefs.setCharPref(tempprefname, nextfieldsListbox.getItemAtIndex(i).value);
	    SetUnicharPref(nextpleasePrefs, tempprefname, nextfieldsListbox.getItemAtIndex(i).value);
	}

    // Save the previous phrase listbox data
    var prevfieldsListbox = document.getElementById('prevfields');
    numRows = prevfieldsListbox.getRowCount();
    nextpleasePrefs.deleteBranch('nextplease.prevphrase.');
    for (var i=0; i<numRows; i++)
	{
	    var tempprefname = 'nextplease.prevphrase.expr' + i;
	    //nextpleasePrefs.setCharPref(tempprefname, prevfieldsListbox.getItemAtIndex(i).value);
	    SetUnicharPref(nextpleasePrefs, tempprefname, prevfieldsListbox.getItemAtIndex(i).value);
	}

    // Save the next image listbox data
    var nextimagefieldsListbox = document.getElementById('nextimagefields');
    var numRows = nextimagefieldsListbox.getRowCount();
    nextpleasePrefs.deleteBranch('nextplease.nextimage.');
    for (var i=0; i<numRows; i++)
	{
	    var tempprefname = 'nextplease.nextimage.expr' + i;
	    //	    nextpleasePrefs.setCharPref(tempprefname, nextimagefieldsListbox.getItemAtIndex(i).value);
	    SetUnicharPref(nextpleasePrefs, tempprefname, nextimagefieldsListbox.getItemAtIndex(i).value);

	}

    // Save the previous image listbox data
    var previmagefieldsListbox = document.getElementById('previmagefields');
    numRows = previmagefieldsListbox.getRowCount();
    nextpleasePrefs.deleteBranch('nextplease.previmage.');
    for (var i=0; i<numRows; i++)
	{
	    var tempprefname = 'nextplease.previmage.expr' + i;
	    // nextpleasePrefs.setCharPref(tempprefname, previmagefieldsListbox.getItemAtIndex(i).value);
	    SetUnicharPref(nextpleasePrefs, tempprefname, previmagefieldsListbox.getItemAtIndex(i).value);
	}


    nextpleasePrefs.setBoolPref('nextplease.allowsubmit',
				document.getElementById("nextpleaseAllowSubmit").checked);
    nextpleasePrefs.setBoolPref('nextplease.allownumbershortcuts',
				document.getElementById("nextpleaseAllowNumberShortcuts").checked);


    alert("Right-click on web page and select 'Next, Please!' to make changes take effect.");

}


//Initialize options
function nextplease_initializeOptions()
{
    var nextpleasePrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");

    keyBindingsChanged = false;
    nextplease_initializeStringToKeyCodeMap(StringToKeyCodeMap);
    nextplease_initializeKeyCodeToStringMap(KeyCodeToStringMap);
    nextplease_initializeNextPhrases();
    nextplease_initializePrevPhrases();
    nextplease_initializeNextImages();
    nextplease_initializePrevImages();

    if (nextpleasePrefs.prefHasUserValue('nextplease.allowsubmit'))
    {
        document.getElementById('nextpleaseAllowSubmit').checked = nextpleasePrefs.getBoolPref('nextplease.allowsubmit');
    } 

    if (nextpleasePrefs.prefHasUserValue('nextplease.allownumbershortcuts'))
    {
        document.getElementById('nextpleaseAllowNumberShortcuts').checked = nextpleasePrefs.getBoolPref('nextplease.allownumbershortcuts');
    } 

    // Read the key binding prefs and set the dialog items appropriately
    if (nextpleasePrefs.prefHasUserValue('nextplease.keymodifier'))
    {
        document.getElementById('nextpleaseModifier').value = nextpleasePrefs.getCharPref('nextplease.keymodifier');
    } 

    if (nextpleasePrefs.prefHasUserValue('nextplease.nextkey'))
	{
	    if (KeyCodeToStringMap[nextpleasePrefs.getIntPref('nextplease.nextkey')])
		{
		    document.getElementById('nextkey').value = '';
		    document.getElementById('nextkeymenu').value = 
			KeyCodeToStringMap[nextpleasePrefs.getIntPref('nextplease.nextkey')];
		}
	    else
		{
		    document.getElementById('nextkeymenu').value = '';
		    document.getElementById('nextkey').value = 
			String.fromCharCode(nextpleasePrefs.getIntPref('nextplease.nextkey'));
		}
	}
    else
	{
	    document.getElementById('nextkeymenu').value = 'Right Arrow';
	    document.getElementById('nextkey').value = '';
	}

    if (nextpleasePrefs.prefHasUserValue('nextplease.prevkey'))
	{
	    if (KeyCodeToStringMap[nextpleasePrefs.getIntPref('nextplease.prevkey')])
		{
		    document.getElementById('prevkey').value = '';
		    document.getElementById('prevkeymenu').value = 
			KeyCodeToStringMap[nextpleasePrefs.getIntPref('nextplease.prevkey')];
		}
	    else
		{
		    document.getElementById('prevkeymenu').value = '';
		    document.getElementById('prevkey').value = 
			String.fromCharCode(nextpleasePrefs.getIntPref('nextplease.prevkey'));
		}
	}
    else
	{
	    document.getElementById('prevkeymenu').value = 'Left Arrow';
	    document.getElementById('prevkey').value = '';
	}
}

function nextplease_OnModifierMenuChange()
{
    keyBindingsChanged = true;
}

function nextplease_OnNextMenuChange()
{
    // Ensure that nextkey and nextkeymenu do not both
    // have an entry
    if (document.getElementById('nextkeymenu').value != '') 
	{
	    document.getElementById('nextkey').value = "";
	}
    if (document.getElementById('nextkeymenu').value == document.getElementById('prevkeymenu').value)
	{
	    document.getElementById('prevkeymenu').value = "";
	}
    keyBindingsChanged = true;
    return true;
}


function nextplease_OnPrevMenuChange()
{
    // Ensure that prevkey and prevkeymenu do not both
    // have an entry
    if (document.getElementById('prevkeymenu').value != '') 
	{
	    document.getElementById('prevkey').value = "";
	}
    if (document.getElementById('nextkeymenu').value == document.getElementById('prevkeymenu').value)
	{
	    document.getElementById('nextkeymenu').value = "";
	}
    keyBindingsChanged = true;
    return true;
}

function nextplease_OnNextKeyChange()
{
    // Ensure that nextkey and nextkeymenu do not both
    // have an entry
    if (document.getElementById('nextkey').value != '') 
	{
	    document.getElementById('nextkeymenu').value = "";
	}
    if (document.getElementById('nextkey').value == document.getElementById('prevkey').value)
	{
	    document.getElementById('prevkey').value = "";
	}
    keyBindingsChanged = true;
    return true;
}

function nextplease_OnPrevKeyChange()
{
    // Ensure that prevkey and prevkeymenu do not both
    // have an entry
    if (document.getElementById('prevkey').value != '') 
	{
	    document.getElementById('prevkeymenu').value = "";
	}
    if (document.getElementById('nextkey').value == document.getElementById('prevkey').value)
	{
	    document.getElementById('nextkey').value = "";
	}
    keyBindingsChanged = true;
    return true;
}

// Add the a next phrase to the listbox
function nextplease_AddNextPhrase()
{
    var nextfieldString = trim(document.getElementById('addnextfield').value);

    if (nextfieldString != '')
	{
	    if(PrevPhrasesMap[nextfieldString])
		alert("'" + nextfieldString + "' is in the Previous Phrases list.");
	    else if(!NextPhrasesMap[nextfieldString])
		{
		    var nextfieldsListbox = document.getElementById('nextfields');
		    nextfieldsListbox.appendItem(nextfieldString, nextfieldString);
		    NextPhrasesMap[nextfieldString] = true;
		    nextfieldsListbox.ensureIndexIsVisible(nextfieldsListbox.getRowCount()-1);
		}
	}
}

// Remove the selected next phrase from the listbox
function nextplease_RemoveNextPhrase()
{
    var nextfieldsListbox = document.getElementById('nextfields');

    var selected = nextfieldsListbox.selectedIndex;
    if (selected >= 0)
	{
	    NextPhrasesMap[nextfieldsListbox.selectedItem.value] = false;
	    nextfieldsListbox.removeItemAt(selected);
	}
}

// Add the a previous phrase to the listbox
function nextplease_AddPrevPhrase()
{
    var prevfieldString = trim(document.getElementById('addprevfield').value);

    if (prevfieldString != '')
	{
	    if(NextPhrasesMap[prevfieldString])
		alert("'" + prevfieldString + "' is in the Next Phrases list.");
	    else if(!PrevPhrasesMap[prevfieldString])
		{
		    var prevfieldsListbox = document.getElementById('prevfields');
		    prevfieldsListbox.appendItem(prevfieldString, prevfieldString);
		    PrevPhrasesMap[prevfieldString] = true;
		    prevfieldsListbox.ensureIndexIsVisible(prevfieldsListbox.getRowCount()-1);
		}
	}

}

// Remove the selected previous phrase from the listbox
function nextplease_RemovePrevPhrase()
{
    var prevfieldsListbox = document.getElementById('prevfields');

    var selected = prevfieldsListbox.selectedIndex;
    if (selected >= 0)
	{
	    PrevPhrasesMap[prevfieldsListbox.selectedItem.value] = false;
	    prevfieldsListbox.removeItemAt(selected);
	}

}

// Add the a next image to the listbox
function nextplease_AddNextImage()
{
    var nextfieldString = trim(document.getElementById('addnextimagefield').value);

    if (nextfieldString != '')
	{
	    if(PrevImagesMap[nextfieldString])
		alert("'" + nextfieldString + "' is in the Previous Images list.");
	    else if(!NextImagesMap[nextfieldString])
		{
		    var nextfieldsListbox = document.getElementById('nextimagefields');
		    nextfieldsListbox.appendItem(nextfieldString, nextfieldString);
		    NextImagesMap[nextfieldString] = true;
		    nextfieldsListbox.ensureIndexIsVisible(nextfieldsListbox.getRowCount()-1);
		}
	}
}

// Remove the selected next image from the listbox
function nextplease_RemoveNextImage()
{
    var nextfieldsListbox = document.getElementById('nextimagefields');

    var selected = nextfieldsListbox.selectedIndex;
    if (selected >= 0)
	{
	    NextImagesMap[nextfieldsListbox.selectedItem.value] = false;
	    nextfieldsListbox.removeItemAt(selected);
	}
}

// Add the a previous image to the listbox
function nextplease_AddPrevImage()
{
    var prevfieldString = trim(document.getElementById('addprevimagefield').value);

    if (prevfieldString != '')
	{
	    if(NextImagesMap[prevfieldString])
		alert("'" + prevfieldString + "' is in the Next Images list.");
	    else if(!PrevImagesMap[prevfieldString])
		{
		    var prevfieldsListbox = document.getElementById('previmagefields');
		    prevfieldsListbox.appendItem(prevfieldString, prevfieldString);
		    PrevImagesMap[prevfieldString] = true;
		    prevfieldsListbox.ensureIndexIsVisible(prevfieldsListbox.getRowCount()-1);
		}
	}

}

// Remove the selected previous image from the listbox
function nextplease_RemovePrevImage()
{
    var prevfieldsListbox = document.getElementById('previmagefields');

    var selected = prevfieldsListbox.selectedIndex;
    if (selected >= 0)
	{
	    PrevImagesMap[prevfieldsListbox.selectedItem.value] = false;
	    prevfieldsListbox.removeItemAt(selected);
	}

}
